<?php

namespace W2e\Feedblock\Controller\Adminhtml\Feedblock;

/**
 * Class NewAction
 * @package W2e\Feedblock\Controller\Adminhtml\Feedblock
 */
class NewAction extends \Magento\Backend\App\Action
{

	/**
	 * @var \Magento\Backend\Model\View\Result\ForwardFactory
	 */
    protected $resultForwardFactory;

	/**
	 * NewAction constructor.
	 *
	 * @param \Magento\Backend\App\Action\Context $context
	 * @param \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
	 */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
    ) {
        $this->resultForwardFactory = $resultForwardFactory;
        parent::__construct($context);
    }

	/**
	 * @return bool
	 */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Ashsmith_Blog::save');
    }

	/**
	 * @return $this
	 */
    public function execute()
    {
        $resultForward = $this->resultForwardFactory->create();
        return $resultForward->forward('edit');
    }
}
